"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ErrorString_1 = require("../../shared/ErrorString");
const InvalidOperationException_1 = require("../../shared/InvalidOperationException");
function aggregate(source, seedOrFunc, func, resultSelector) {
    if (resultSelector) {
        if (!func) {
            throw new ReferenceError(`TAccumulate function is undefined`);
        }
        return aggregate3(source, seedOrFunc, func, resultSelector);
    }
    else if (func) {
        return aggregate2(source, seedOrFunc, func);
    }
    else {
        return aggregate1(source, seedOrFunc);
    }
}
exports.aggregate = aggregate;
const aggregate1 = async (source, func) => {
    var e_1, _a;
    let aggregateValue;
    try {
        for (var source_1 = tslib_1.__asyncValues(source), source_1_1; source_1_1 = await source_1.next(), !source_1_1.done;) {
            const value = source_1_1.value;
            if (aggregateValue) {
                aggregateValue = func(aggregateValue, value);
            }
            else {
                aggregateValue = value;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (source_1_1 && !source_1_1.done && (_a = source_1.return)) await _a.call(source_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (aggregateValue === undefined) {
        throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
    }
    return aggregateValue;
};
const aggregate2 = async (source, seed, func) => {
    var e_2, _a;
    let aggregateValue = seed;
    try {
        for (var source_2 = tslib_1.__asyncValues(source), source_2_1; source_2_1 = await source_2.next(), !source_2_1.done;) {
            const value = source_2_1.value;
            aggregateValue = func(aggregateValue, value);
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (source_2_1 && !source_2_1.done && (_a = source_2.return)) await _a.call(source_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return aggregateValue;
};
const aggregate3 = async (source, seed, func, resultSelector) => {
    var e_3, _a;
    let aggregateValue = seed;
    try {
        for (var source_3 = tslib_1.__asyncValues(source), source_3_1; source_3_1 = await source_3.next(), !source_3_1.done;) {
            const value = source_3_1.value;
            aggregateValue = func(aggregateValue, value);
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (source_3_1 && !source_3_1.done && (_a = source_3.return)) await _a.call(source_3);
        }
        finally { if (e_3) throw e_3.error; }
    }
    return resultSelector(aggregateValue);
};
