"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const from_1 = require("../../parallel/_private/from");
/**
 * Converts an async iterable to a Parallel Enumerable.
 * @param source AsyncIterable<T> to convert to IParallelEnumerable<T>
 * @returns Parallel Enumerable of source
 */
function asParallel(source) {
    async function generator() {
        var e_1, _a;
        const data = [];
        try {
            for (var source_1 = tslib_1.__asyncValues(source), source_1_1; source_1_1 = await source_1.next(), !source_1_1.done;) {
                const value = source_1_1.value;
                data.push(value);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (source_1_1 && !source_1_1.done && (_a = source_1.return)) await _a.call(source_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return data;
    }
    return from_1.from(0 /* PromiseToArray */, generator);
}
exports.asParallel = asParallel;
