"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ErrorString_1 = require("../../shared/ErrorString");
const InvalidOperationException_1 = require("../../shared/InvalidOperationException");
function average(source, selector) {
    if (selector) {
        return average2(source, selector);
    }
    else {
        return average1(source);
    }
}
exports.average = average;
const average1 = async (source) => {
    var e_1, _a;
    let value;
    let count;
    try {
        for (var source_1 = tslib_1.__asyncValues(source), source_1_1; source_1_1 = await source_1.next(), !source_1_1.done;) {
            const item = source_1_1.value;
            value = (value || 0) + item;
            count = (count || 0) + 1;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (source_1_1 && !source_1_1.done && (_a = source_1.return)) await _a.call(source_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (value === undefined) {
        throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
    }
    return value / count;
};
const average2 = async (source, func) => {
    var e_2, _a;
    let value;
    let count;
    try {
        for (var source_2 = tslib_1.__asyncValues(source), source_2_1; source_2_1 = await source_2.next(), !source_2_1.done;) {
            const item = source_2_1.value;
            value = (value || 0) + func(item);
            count = (count || 0) + 1;
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (source_2_1 && !source_2_1.done && (_a = source_2.return)) await _a.call(source_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    if (value === undefined) {
        throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
    }
    return value / count;
};
