import { from } from "../../async/_private/from";
/**
 * Converts a IEnumerable enumerable to an async one.
 * @param source A parallel IEnumerable
 */
export function asAsync(source) {
    async function* generator() {
        for await (const value of source) {
            yield value;
        }
    }
    return from(generator);
}
