"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
// tslint:disable:interface-name
/**
 * Base implementation of IParallelEnumerable<T>
 * @private
 */
class BasicParallelEnumerable {
    constructor(dataFunc) {
        this.dataFunc = dataFunc;
    }
    [Symbol.asyncIterator]() {
        const thisOuter = this;
        function iterator() {
            return tslib_1.__asyncGenerator(this, arguments, function* iterator_1() {
                const dataFunc = thisOuter.dataFunc;
                switch (dataFunc.type) {
                    case 1 /* ArrayOfPromises */:
                        for (const value of dataFunc.generator()) {
                            yield yield tslib_1.__await(value);
                        }
                        break;
                    case 2 /* PromiseOfPromises */:
                        for (const value of yield tslib_1.__await(dataFunc.generator())) {
                            yield yield tslib_1.__await(value);
                        }
                        break;
                    case 0 /* PromiseToArray */:
                    default:
                        for (const value of yield tslib_1.__await(dataFunc.generator())) {
                            yield yield tslib_1.__await(value);
                        }
                        break;
                }
            });
        }
        return iterator();
    }
}
exports.BasicParallelEnumerable = BasicParallelEnumerable;
