"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ErrorString_1 = require("../../shared/ErrorString");
const InvalidOperationException_1 = require("../../shared/InvalidOperationException");
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const _nextIteration_1 = require("./_nextIteration");
async function max(source, selector) {
    let maxInfo;
    if (selector) {
        const dataFunc = _nextIteration_1.nextIteration(source, selector);
        maxInfo = await new BasicParallelEnumerable_1.BasicParallelEnumerable(dataFunc).toArray();
    }
    else {
        maxInfo = await source.toArray();
    }
    if (maxInfo.length === 0) {
        throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
    }
    return Math.max.apply(null, maxInfo);
}
exports.max = max;
