"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const from_1 = require("../../async/_private/from");
/**
 * Performs a specified action on each element of the Iterable<TSource>
 * @param source The source to iterate
 * @param action The action to take an each element
 * @returns A new IAsyncEnumerable<T> that executes the action lazily as you iterate.
 */
function eachAsync(source, action) {
    function generator() {
        return tslib_1.__asyncGenerator(this, arguments, function* generator_1() {
            for (const value of source) {
                yield tslib_1.__await(action(value));
                yield yield tslib_1.__await(value);
            }
        });
    }
    return from_1.from(generator);
}
exports.eachAsync = eachAsync;
