"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Paritions the Iterable<T> into a tuple of failing and passing arrays
 * based on the predicate.
 * @param source Elements to Partition
 * @param predicate Async Pass / Fail condition
 * @returns Promise of [pass, fail]
 */
async function partitionAsync(source, predicate) {
    const fail = [];
    const pass = [];
    for (const value of source) {
        if (await predicate(value) === true) {
            pass.push(value);
        }
        else {
            fail.push(value);
        }
    }
    return [pass, fail];
}
exports.partitionAsync = partitionAsync;
