"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const from_1 = require("../../async/_private/from");
function selectAsync(source, selector) {
    if (typeof selector === "function") {
        if (selector.length === 1) {
            return selectAsync1(source, selector);
        }
        else {
            return selectAsync2(source, selector);
        }
    }
    else {
        return selectAsync3(source, selector);
    }
}
exports.selectAsync = selectAsync;
const selectAsync1 = (source, selector) => {
    function iterator() {
        return tslib_1.__asyncGenerator(this, arguments, function* iterator_1() {
            for (const value of source) {
                yield yield tslib_1.__await(selector(value));
            }
        });
    }
    return from_1.from(iterator);
};
const selectAsync2 = (source, selector) => {
    function iterator() {
        return tslib_1.__asyncGenerator(this, arguments, function* iterator_2() {
            let index = 0;
            for (const value of source) {
                yield yield tslib_1.__await(selector(value, index));
                index++;
            }
        });
    }
    return from_1.from(iterator);
};
const selectAsync3 = (source, key) => {
    function iterator() {
        return tslib_1.__asyncGenerator(this, arguments, function* iterator_3() {
            for (const value of source) {
                yield yield tslib_1.__await(value[key]);
            }
        });
    }
    return from_1.from(iterator);
};
